%define anolis_release 3
%global fontname bitmap
%global fontconf 66-%{fontname}

Name: bitmap-fonts
Version: 0.3
Epoch: 1
Release: %{anolis_release}%{?dist}
Summary: Selected set of %{fontname} fonts
License: GPLv2 and MIT and Lucida
Source0: %{name}-%{version}.tar.bz2
Source1: fixfont-3.5.tar.bz2
Source2: LICENSE
Source3: %{fontconf}-console.conf
Source4: %{fontconf}-fangsongti.conf
Source5: %{fontconf}-fixed.conf
Source6: %{fontconf}-lucida-typewriter.conf
BuildArch: noarch

BuildRequires: bdftopcf fonttosfnt python3 /usr/bin/ftdump make
BuildRequires: fontpackages-devel

%description
The %{name} package provides a number of %{fontname} fonts selected
from the xorg package designed for use locations such as terminals.

%package -n %{fontname}-console-fonts
Summary: Selected set of %{fontname} fonts
Requires: fontpackages-filesystem
License: GPLv2
Conflicts: %{fontname}-console-opentype-fonts

%description -n %{fontname}-console-fonts
The %{name} package provides a number of %{fontname} fonts selected
from the xorg package designed for use locations such as terminals.
Selected set of %{fontname} fonts.

%package -n %{fontname}-console-opentype-fonts
Summary: Selected set of %{fontname} fonts (opentype version)
Requires: fontpackages-filesystem
License: GPLv2
Conflicts: %{fontname}-console-fonts

%description -n %{fontname}-console-opentype-fonts
The %{name} package provides a number of %{fontname} fonts selected
from the xorg package designed for use locations such as terminals.
Selected set of %{fontname} fonts (opentype version).

%package -n %{fontname}-fangsongti-fonts
Summary: Selected CJK %{fontname} fonts for Anaconda
Requires: fontpackages-filesystem
Provides: %{name}-cjk = %{EVR}
License: MIT
Conflicts: %{fontname}-fangsongti-opentype-fonts

%description -n %{fontname}-fangsongti-fonts
The %{name} package provides a number of %{fontname} fonts selected
from the xorg package designed for use locations such as terminals.
Selected CJK %{fontname} fonts for Anaconda.

%package -n %{fontname}-fangsongti-opentype-fonts
Summary: Selected CJK %{fontname} fonts for Anaconda (opentype version)
Requires: fontpackages-filesystem
License: MIT
Conflicts: %{fontname}-fangsongti-fonts

%description -n %{fontname}-fangsongti-opentype-fonts
The %{name} package provides a number of %{fontname} fonts selected
from the xorg package designed for use locations such as terminals.
Selected CJK %{fontname} fonts for Anaconda (opentype version).

%package -n %{fontname}-fixed-fonts
Summary: Selected set of %{fontname} fonts
Requires: fontpackages-filesystem
License: GPLv2
Conflicts: %{fontname}-fixed-opentype-fonts

%description -n %{fontname}-fixed-fonts
The %{name} package provides a number of %{fontname} fonts selected
from the xorg package designed for use locations such as terminals.
Selected set of %{fontname} fonts.

%package -n %{fontname}-fixed-opentype-fonts
Summary: Selected set of %{fontname} fonts (opentype version)
Requires: fontpackages-filesystem
License: GPLv2
Conflicts: %{fontname}-fixed-fonts

%description -n %{fontname}-fixed-opentype-fonts
The %{name} package provides a number of %{fontname} fonts selected
from the xorg package designed for use locations such as terminals.
Selected set of %{fontname} fonts (opentype version).

%package -n %{fontname}-fonts-compat
Summary: Compatibility files of %{name} families
Provides: %{name} = %{EVR}
Requires: %{fontname}-console-fonts = %{EVR}
Requires: %{fontname}-fangsongti-fonts = %{EVR}
Requires: %{fontname}-fixed-fonts = %{EVR}
Requires: %{fontname}-lucida-typewriter-fonts = %{EVR}
Requires: ucs-miscfixed-fonts
Obsoletes: %{name} < %{EVR}
Conflicts: %{fontname}-opentype-fonts-compat

%description -n %{fontname}-fonts-compat
The %{name} package provides a number of %{fontname} fonts selected
from the xorg package designed for use locations such as terminals.
Meta-package for installing all font families of %{fontname}.

%package -n %{fontname}-lucida-typewriter-fonts
Summary: Selected CJK %{fontname} fonts for Anaconda
Requires: fontpackages-filesystem
Provides: %{name}-cjk = %{EVR}
License: Lucida
Conflicts: %{fontname}-lucida-typewriter-opentype-fonts

%description -n %{fontname}-lucida-typewriter-fonts
The %{name} package provides a number of %{fontname} fonts selected
from the xorg package designed for use locations such as terminals.
Selected CJK %{fontname} fonts for Anaconda.

%package -n %{fontname}-lucida-typewriter-opentype-fonts
Summary: Selected CJK %{fontname} fonts for Anaconda (opentype version)
Requires: fontpackages-filesystem
License: Lucida
Conflicts: %{fontname}-lucida-typewriter-fonts

%description -n %{fontname}-lucida-typewriter-opentype-fonts
The %{name} package provides a number of %{fontname} fonts selected
from the xorg package designed for use locations such as terminals.
Selected CJK %{fontname} fonts for Anaconda (opentype version).

%package -n %{fontname}-opentype-fonts-compat
Summary:  Compatibility files of %{name} families (opentype version)
Requires: %{fontname}-console-opentype-fonts = %{EVR}
Requires: %{fontname}-fangsongti-opentype-fonts = %{EVR}
Requires: %{fontname}-fixed-opentype-fonts = %{EVR}
Requires: %{fontname}-lucida-typewriter-opentype-fonts = %{EVR}
Requires: ucs-miscfixed-opentype-fonts
Conflicts: %{fontname}-fonts-compat

%description -n %{fontname}-opentype-fonts-compat
The %{name} package provides a number of %{fontname} fonts selected
from the xorg package designed for use locations such as terminals.
Meta-package for installing all font families of opentype %{fontname}.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -n %{name}-%{version} -a 1
install -m 0644 -p %{SOURCE2} .

%build
%{nil}

%install
rm -rf %{buildroot}

make install DESTDIR=%{buildroot}

pushd fixfont-3.5
make install DESTDIR=%{buildroot}
popd

mv %{buildroot}/usr/share/fonts/%{name} %{buildroot}%{_fontdir}

rm %{buildroot}%{_fontdir}/[0-9]*.pcf
rm %{buildroot}%{_fontdir}/console8x8.pcf

# Convert to OpenType Bitmap Font
rm [0-9]*.bdf fixfont-3.5/[0-9]*.bdf

for bdf in `ls *.bdf`;
do fonttosfnt -b -c -g 2 -m 2 -o ${bdf%%bdf}otb  $bdf;
done
install -m 0644 -p *.otb %{buildroot}%{_fontdir}

pushd fixfont-3.5
for bdf in `ls *.bdf`;
do fonttosfnt -b -c -g 2 -m 2 -o ${bdf%%bdf}otb  $bdf;
done
fonttosfnt -b -c -g 2 -m 2 -o console9x15.otb console9x15.pcf

install -m 0644 -p *.otb %{buildroot}%{_fontdir}
popd

gzip %{buildroot}%{_fontdir}/*.pcf

install -m 0755 -d %{buildroot}%{_fontconfig_templatedir} \
                   %{buildroot}%{_fontconfig_confdir}

install -m 0644 -p %{SOURCE3} \
        %{buildroot}%{_fontconfig_templatedir}/%{fontconf}-console.conf

install -m 0644 -p %{SOURCE4} \
        %{buildroot}%{_fontconfig_templatedir}/%{fontconf}-fangsongti.conf

install -m 0644 -p %{SOURCE5} \
        %{buildroot}%{_fontconfig_templatedir}/%{fontconf}-fixed.conf

install -m 0644 -p %{SOURCE6} \
        %{buildroot}%{_fontconfig_templatedir}/%{fontconf}-lucida-typewriter.conf


for fconf in %{fontconf}-console.conf \
             %{fontconf}-fangsongti.conf \
             %{fontconf}-fixed.conf \
             %{fontconf}-lucida-typewriter.conf ; do
  ln -s %{_fontconfig_templatedir}/$fconf \
        %{buildroot}%{_fontconfig_confdir}/$fconf
done

%_font_pkg -n console -f %{fontconf}-console.conf console8x16*.pcf.gz

%_font_pkg -n console-opentype -f %{fontconf}-console.conf console8x16*.otb

%_font_pkg -n fangsongti -f %{fontconf}-fangsongti.conf fangsongti*.pcf.gz
%license LICENSE

%_font_pkg -n fangsongti-opentype -f %{fontconf}-fangsongti.conf fangsongti*.otb
%license LICENSE

%_font_pkg -n fixed-opentype -f %{fontconf}-fixed.conf console9*.otb

%_font_pkg -n fixed -f %{fontconf}-fixed.conf  console9*.pcf.gz

%_font_pkg -n lucida-typewriter -f %{fontconf}-lucida-typewriter.conf lut*.pcf.gz

%_font_pkg -n lucida-typewriter-opentype -f %{fontconf}-lucida-typewriter.conf lut*.otb

%files -n %{fontname}-fonts-compat

%files -n %{fontname}-opentype-fonts-compat

%files doc
%doc LU_LEGALNOTICE README fixfont-3.5/README

%changelog
* Wed Apr 12 2023 Jing Zhang <renyu.zj@linux.alibaba.com> - 1:0.3-3
- Refact spec

* Tue Jul 26 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 1:0.3-2
- fix version dependency

* Tue Apr 19 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 1:0.3-1
- init from upstream
- add epoch version to make sure update
